<SCRIPT LANGUAGE=JSCRIPT RUNAT=SERVER>
/*
 * Cerca un tag specificato all'interno del file dei TAG 
 * Ritorna il tag cercato o NULL se non trovato.
 */
function LeggiTag( TagID, fileName )
{
   var fso;             // FileSystemObject
   var file;            // Fiile dei tag
   var elem;            // elementi del tag
   var tag = null;      // tag da ritornare
   var ro = / /g;       // RegularExpression usata per 'magniare' gli spazi
   var i=1;
      
   // Creo un nuovo oggetto FileSystem
   fso=new ActiveXObject( "Scripting.FileSystemObject" );
   
   // accedo al file dei tag
   // N.B. non verifico se il file esiste... mica troppo bello
   file = fso.OpenTextFile( fileName )

   // elimino gli spazi all'interno del codice
   TagID = TagID.replace( ro, "" );
   
   // ciclo e leggo tutti i Tag
   while( ! file.AtEndOfStream )
   {
      // leggo il singolo Tag
      tag = file.ReadLine();
      
      // parserizzo suddividendo in Codice e Testo ed
      // elimino gli spazi
      elem = SeparaTag( tag, null );
      elem[0] = elem[0].replace( ro, "" );
      
      // verifico di aver trovato il tag che cercavo
      tag="";
      if( TagID == elem[0] )
      {
         // ritorno il tag
         for( i=1; i < elem.length; i++ )
           tag += elem[i];
         break;
      }
   }

   // chiudo il file
   file.close();
   
   // ritorno il tag trovato o Null
   return tag;

}

/*
   SeparaTag
   
   Separa un Tag letto dal file nei suoi elementi
   un codice ed una stringa che vengono ritornati in un array
   costruito per l'occasione.
   
   Parametri:
   tag         &egrave il tag letto dal file
   separatore  &egrave il carattere usato per dividere i due pezzi, se null si intende ';'.
   
*/
function SeparaTag( tag, sep )
{
   var ro;
   
   // se il separatore non &egrave specificato assumo ";"
   if( sep == null )
   {
      ro = new RegExp( "@", "g" );
   }
   else
   {
      ro = new RegExp( sep, "g" );
   }

   return tag.split( ro );
   
}

/*
* Recupera un tag e lo scrive nel report
* Funzione che viene usato dappertutto
*
* tagFile e' il nome del file dei tag da usare
* reportFile e' un File gia' aperto.
* tag e' l'ID del tag da inserire
*
*/
function ScriviTagNelReport( tagFile, reportFile, tag )
{
  var tmpTag;
  
  // recupero il tag di inizializzazione e lo scrivo nel file
  tmpTag = LeggiTag( tag, tagFile );
  reportFile.Write( tmpTag );
  
}

/*
* Inizializza il report
* Crea il file denominato "reportFile" e scrive
* i tag di inizializzazione dell'RTF. I tag sono
* letti dal file indicato come "tagFile"
*
* Ritorna il nuovo oggetto File creato.
*/
function IniziaReport( reportFile, tagFile )
{
  var fso;        // FileSystemObject
  var fileReport; // file del Report
  var tag;        // tag
  
  // creo l'oggetto FSO
  fso = new ActiveXObject("Scripting.FileSystemObject");
  
  // creo il file del report
  fileReport = fso.CreateTextFile( reportFile );
  
  // recupero il tag di inizializzazione e lo scrivo nel file
  ScriviTagNelReport( tagFile, fileReport, "InizializzaReport" );
  
  // ritorno il report appena creato
  return fileReport;
  
}

/*
* Termina il report
* Scrive nel report indicato i tag di chiusura dell'RTF e
* chiude il file.
*/
function ChiudiReport( reportFile, tagFile )
{
  var fileReport; // file del Report
  var tag;        // tag
  
  // recupero il tag di chiusura e lo scrivo nel file
  ScriviTagNelReport( tagFile, reportFile, "TerminaReport" );
  
  // chiudo il file
  reportFile.Close();
  
}

/*
* Imposta il formato pagina a Portrait
*/
function ImpostaPortrait( reportFile, tagFile )
{
  var tag;        // tag
  
  // recupero il tag di inizializzazione e lo scrivo nel file
  ScriviTagNelReport( tagFile, reportFile, "Portrait" );
}

/*
* Imposta il formato pagina a Landscape
*/
function ImpostaLandscape( reportFile, tagFile )
{
  var tag;        // tag
  
  // recupero il tag di inizializzazione e lo scrivo nel file
  ScriviTagNelReport( tagFile, reportFile, "Landscape" );
}

/*
* Scrive una linea senza mettere una fine paragrafo
* testo e' il testo da scrivere
*
* N.B. 'tagFile' non e' usato, ma viene richiesto per
* mantenere una certa coerenza con tutte le altre funzioni.
*/
function ScriviLinea( reportFile, tagFile, testo )
{
  reportFile.WriteLine( testo + " " );
}

/*
* Scrive una linea aggiungendo la fine del paragrafo
*/
function ScriviLineaACapo( reportFile, tagFile, testo )
{
  reportFile.WriteLine( testo + " ");
  ChiudiParagrafo( reportFile, tagFile );
}

/*
* Inserisce la fine del paragrafo
*/
function ChiudiParagrafo( reportFile, tagFile )
{
  ScriviTagNelReport( tagFile, reportFile, "FineParagrafo" );
}

/*
* Inserisce l'inizio della Tabella degli Stili
*/
function IniziaTabellaStili( reportFile, tagFile )
{
  ScriviTagNelReport( tagFile, reportFile, "InizioTabellaStili" );
}

/*
* Inserisce lo stile nella tabella
*/
function InserisciStile( reportFile, tagFile, stile )
{
  ScriviTagNelReport( tagFile, reportFile, stile )
}

/*
* Chiude la tabella stili
*/
function ChiudiTabellaStili( reportFile, tagFile )
{
  ScriviTagNelReport( tagFile, reportFile, "FineTabellaStili" );
}

/*
* Inserisce la tabella degli stili 'default'
*/
function InserisciTabellaStili( reportFile, tagFile )
{
  // inizializzo la tabella
  IniziaTabellaStili( reportFile, tagFile );
  
  // inserisco gli stili
  InserisciStile( reportFile, tagFile, "Titolo1" );
  InserisciStile( reportFile, tagFile, "Titolo2" );
  InserisciStile( reportFile, tagFile, "Titolo3" );
  InserisciStile( reportFile, tagFile, "Titolo4" );
  InserisciStile( reportFile, tagFile, "Normale" );
  InserisciStile( reportFile, tagFile, "Testo" );
  InserisciStile( reportFile, tagFile, "PieDiPagina" );
  InserisciStile( reportFile, tagFile, "Intestazione" );

  // chiudo la tabella degli stili
  ChiudiTabellaStili( reportFile, tagFile );
  
}

/*
* Inizia a scrivere con uno stile
*/
function IniziaStile( reportFile, tagFile, stile )
{
  ScriviTagNelReport( tagFile, reportFile, "Stile_" + stile );
}

/*
* Termina lo stile corrente
*/
function ChiudiStile( reportFile, tagFile )
{
   ScriviTagNelReport( tagFile, reportFile, "FineStile" );
}

/*
* Mette il testo in grassetto
*/
function AttivaGrassetto( reportFile, tagFile )
{
  ScriviTagNelReport( tagFile, reportFile, "InizioGrassetto" );
}

/*
* Mette il testo in corsivo
*/
function AttivaCorsivo( reportFile, tagFile )
{
  ScriviTagNelReport( tagFile, reportFile, "InizioCorsivo" );
}

/*
* Disattiva il grassetto
*/
function FineGrassetto( reportFile, tagFile )
{
  ScriviTagNelReport( tagFile, reportFile, "FineGrassetto" );
}

/*
* Disattiva il corsivo
*/
function FineCorsivo( reportFile, tagFile )
{
  ScriviTagNelReport( tagFile, reportFile, "FineCorsivo" );
}

/*
* Imposta una tabulazione
*/
function ImpostaTabulazione( reportFile, tagFile, tabulazione )
{
  var tabTwips;
  var tag;
  
  tabTwips = tabulazione * 56.7
  tag = LeggiTag( "Tabulazione", tagFile ) + tabTwips;
  reportFile.Write( tag );

}

/*
* Inizia una linea tabulata
*/
function IniziaLinea( reportFile, tagFile )
{
  ScriviTagNelReport( tagFile, reportFile, "InitTab" );
}

/*
* Chiude una linea tabulata
*/
function FinisciLinea( reportFile, tagFile )
{
  ScriviTagNelReport( tagFile, reportFile, "EndTab" );
}

/*
* Inserisce un carattere di tabulazione
*/
function InserisiciTab( reportFile, tagFile )
{
  ScriviTagNelReport( tagFile, reportFile, "Tab" );
}
</SCRIPT>
